-- name: [CS] Grey Man
-- description: Wrong console, right polycount\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation

    Use this if you're curious on how anything here works >v<
	(This is an edited version of the Template File by Squishy)
]]

local TEXT_MOD_NAME = "The Grey Man"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_CUSTOM_MODEL = smlua_model_util_get_id("LSDGREYMAN_geo") -- Located in "actors"

local TEX_CUSTOM_LIFE_ICON = get_texture_info("lsdgm_lives") -- Located in "textures"

-- All Located in "sound" Name them whatever you want. Remember to include the .ogg extension
local VOICETABLE_LSDGREYMAN = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'StartLevel.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'GM_AmbientHopeful.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'GM_CartHitB.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'GM_CartHitA.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'GM_EHitB.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'GM_DrumA.ogg', 'GM_DrumC.ogg', 'GM_DrumB.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'GM_DrumD.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'GM_SnareB.ogg', 'GM_SnareC.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'GM_HumColl1.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'GM_HumColl2.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'GM_HumColl2.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'GM_LovJingleLow.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'GM_ElectroLaunch.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'GM_DeepBassGrunt.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'GM_SFXGrass.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'GM_SFXSwitch.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'GM_DeepBassYell.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'GM_SharpDidge.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'GM_SFXTile.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'GM_AmbientHopeful.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'GM_JChantDeep.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Silent.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'GM_DarkSitarA.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'GM_WegaScream.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'GM_DarkSitarB.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'GM_ElecPowDown.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'GM_LovPing.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'GM_LovSigh.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'GM_Gargle.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'GM_HumanCough.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'GM_Breathing.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'GM_HumColl7.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'GM_DisquietTone.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'GM_LovBrownNote.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Silent.ogg' -- Booted out of level
}

-- All Located in "actors"
local CAPTABLE_CHAR = {
    normal = smlua_model_util_get_id("LSDGREYMAN_capnormal_geo"),
    wing = smlua_model_util_get_id("LSDGREYMAN_wingcap_geo"),
    metal = smlua_model_util_get_id("LSDGREYMAN_metalcap_geo"),
}

local PALETTE_CHAR = {
    [PANTS]  = "020019",
    [SHIRT]  = "020019",
    [GLOVES] = "020019",
    [SHOES]  = "020019",
    [HAIR]   = "ffffff",
    [SKIN]   = "020019",
    [CAP]    = "020019",
	[EMBLEM] = "ffffff"
}

--local HM_CHARNAME2= {
--    label = {
--        left = get_texture_info("HealthLeft"),
--        right = get_texture_info("HealthRight"),
--    },
--    pie = {
--        [1] = get_texture_info("Pie1"),
--        [2] = get_texture_info("Pie2"),
--        [3] = get_texture_info("Pie3"),
--        [4] = get_texture_info("Pie4"),
--        [5] = get_texture_info("Pie5"),
--        [6] = get_texture_info("Pie6"),
--        [7] = get_texture_info("Pie7"),
--        [8] = get_texture_info("Pie8"),
--    }
--}

local CSloaded = false
local function on_character_select_load()
    CT_LSDGREYMAN = _G.charSelect.character_add("Grey Man", {"Shadow entity from LSD: Dream Emulator", "Also from your benadryl-fueled hallucinations"}, "CornObjects", {r = 100, g = 100, b = 100}, E_MODEL_CUSTOM_MODEL, CT_WALUIGI, TEX_CUSTOM_LIFE_ICON)
    _G.charSelect.character_add_caps(E_MODEL_CUSTOM_MODEL, CAPTABLE_CHAR)
    _G.charSelect.character_add_voice(E_MODEL_CUSTOM_MODEL, VOICETABLE_LSDGREYMAN)
    _G.charSelect.character_add_celebration_star(E_MODEL_CUSTOM_MODEL, E_MODEL_CUSTOM_STAR, TEX_CUSTOM_STAR_ICON)
    _G.charSelect.character_add_palette_preset(E_MODEL_CUSTOM_MODEL, PALETTE_CHAR)
    _G.charSelect.character_add_health_meter(CT_CHARNAME2, HM_CHARNAME2)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_LSDGREYMAN then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_LSDGREYMAN then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)